package com.winhc.bigdata.spark.jobs

import com.winhc.bigdata.spark.utils.{CompanyIncrForCidUtils, SparkUtils}
import org.apache.spark.sql.SparkSession

import scala.collection.mutable

/**
 * 增量数据更新
 * π
 */

//liscense,domain,new_cid winhc_eci_dev.inc_ods_company winhc_eci_dev.ads_company_icp winhc_eci_dev.inc_ods_company_icp winhc_eci_dev.inc_ads_company_icp
//winhc_eci_dev.tmp_xf_inc_ods_company_icp_2
object CompanyIncrForCid {

  val tabMapping: Map[String, (String, String, String, String, String)] =
    Map("ods_company_icp" -> ("liscense,domain,new_cid", "inc_ods_company", "ads_company_icp", "inc_ods_company_icp", "winhc_eci_dev.inc_ads_company_icp"), //网站
      "ods_company_tm" -> ("reg_no,new_cid", "", "", "", ""), //商标
      "ods_company_wechat" -> ("public_num,new_cid", "", "", "", ""), //微信公众号
      "ods_company_app_info" -> ("name,new_cid", "", "", "", ""), //产品信息
      "ods_company_own_tax" -> ("own_tax_amount,tax_category,tax_num,new_cid", "", "", "", ""), //税
      "ods_company_mortgage_info" -> ("reg_date,reg_num,amount,new_cid", "", "", "", "") //
    )


  //winhc_eci_dev company_icp liscense,domain,new_cid
  def main(args: Array[String]): Unit = {
    //    val (cols, t1, t2, t3, t4) = valid(args)
    val Array(project, tableName, dupliCols) = args
    println(
      s"""
         |$project
         |$tableName
         |$dupliCols
         |""".stripMargin)
    val config = mutable.Map(
      "spark.hadoop.odps.project.name" -> "winhc_eci_dev",
      "spark.hadoop.odps.spark.local.partition.amt" -> "10"
    )
    val spark: SparkSession = SparkUtils.InitEnv(this.getClass.getSimpleName, config)
    CompanyIncrForCidUtils(spark, project, tableName, (dupliCols.split(",").toSeq)).calc()
    //    CompanyIncrForCidUtils(spark, t1, t2, t3, t4, cols).calc()
    spark.stop()
  }

  def valid(args: Array[String]): (Seq[String], String, String, String, String) = {
    println(args.toSeq.mkString(" "))

    if (args.length == 1) {

    } else if (args.length == 5) {
      val Array(cols, t1, t2, t3, t4) = args
      return (cols.split(",").toSeq, t1, t2, t3, t4)
    } else {
      println("请输入要计算的table!!!! ")
      sys.exit(-1)
    }
    val Array(sourceTable) = args
    val space = sourceTable.split("\\.")(0) + "."

    val (cols, t1, t2, t3, t4) = tabMapping.getOrElse(sourceTable.split("\\.")(1), null)
    if (cols.isEmpty) {
      println("输入表不存在,请配置计算规则!!!   ")
      sys.exit(-1)
    }

    (cols.split(",").toSeq, space + t1, space + t2, space + t3, space + t4)
  }
}
