package com.winhc.bigdata.spark.utils

import com.winhc.bigdata.spark.utils.BaseUtil.isWindows
import org.apache.hadoop.conf.Configuration
import org.apache.hadoop.hbase.mapred.TableOutputFormat
import org.apache.hadoop.hbase.{HBaseConfiguration, HConstants}
import org.apache.hadoop.mapred.JobConf

/**
 * @Author: XuJiakai
 * @Date: 2020/6/3 19:03
 * @Description:
 */
object HBaseUtils {
  def getHbaseConf(): Configuration = {
    val config = HBaseConfiguration.create()
    var zkAddress: String = null
    if (isWindows) {
      zkAddress = "hb-proxy-pub-uf63a7d09rpl8mcvm-001.hbase.rds.aliyuncs.com"
      import com.alibaba.dcm.DnsCacheManipulator
      DnsCacheManipulator.setDnsCache("hb-uf63a7d09rpl8mcvm-001.hbase.rds.aliyuncs.com", "47.101.250.84")
    } else {
      zkAddress = "hb-uf6m8e1nu4ivp06m5-master1-001.hbase.rds.aliyuncs.com,hb-uf6m8e1nu4ivp06m5-master2-001.hbase.rds.aliyuncs.com,hb-uf6m8e1nu4ivp06m5-master3-001.hbase.rds.aliyuncs.com"
//      zkAddress = "hb-uf63a7d09rpl8mcvm-001.hbase.rds.aliyuncs.com"

      //      zkAddress = "ld-uf6717qu3qh1t80z8-proxy-hbaseue.hbaseue.rds.aliyuncs.com:30020"
      //      config.set("hbase.client.username", "root");
      //      config.set("hbase.client.password", "root");
      //      config.set("hbase.client.connection.impl", "org.apache.hadoop.hbase.client.AliHBaseUEClusterConnection");
    }
    config.set(HConstants.ZOOKEEPER_QUORUM, zkAddress);
    config
  }

  def HBaseOutputJobConf(outputTable: String): JobConf = {
    val jobConf = new JobConf(getHbaseConf())
    jobConf.setOutputFormat(classOf[TableOutputFormat])
    jobConf.set(TableOutputFormat.OUTPUT_TABLE, outputTable)
    jobConf
  }
}
